=== debian/changelog ===
botch (0.4-1) unstable; urgency=medium

  * New upstream release.

 -- Johannes Schauer <j.schauer@email.de>  Tue, 14 Oct 2014 01:26:25 +0200

botch (0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Johannes Schauer <j.schauer@email.de>  Sun, 12 Oct 2014 08:51:01 +0200

botch (0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Johannes Schauer <j.schauer@email.de>  Sun, 12 Oct 2014 02:03:02 +0200

botch (0.1-1) unstable; urgency=medium

  * Initial release. (Closes: #748102)

 -- Johannes Schauer <j.schauer@email.de>  Wed, 14 May 2014 11:54:59 +0200
