=== debian/control ===
Source: botch
Section: utils
Priority: extra
Maintainer: Johannes Schauer <j.schauer@email.de>
Homepage: https://gitorious.org/debian-bootstrap/pages/Home
Standards-Version: 3.9.5
# all build dependencies after the *-dev dependencies are only needed to run
# the testsuite
Build-Depends:
 debhelper (>= 9),
 ocaml-nox,
 camlp4,
 python3,
 graphviz,
 markdown,
 ocaml-findlib,
 libextlib-ocaml-dev,
 libocamlgraph-ocaml-dev,
 libatdgen-ocaml-dev,
 libxmlm-ocaml-dev,
 libdose3-ocaml-dev (>= 3.2.2),
 dose-builddebcheck (>= 3.2.2),
 dose-extra (>= 3.2.2),
 dctrl-tools,
 aspcud,
 python3-apt,
 python3-debian,
 python3-networkx,
 python3-yaml,
 pep8,
 pyflakes
XS-Testsuite: autopkgtest

Package: botch
Architecture: any
Depends:
 ${ocaml:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
 dose-builddebcheck (>= 3.2.2),
 dose-extra (>= 3.2.2),
 dctrl-tools,
 aspcud,
 python3-apt,
 python3-debian,
 python3-networkx,
 python3-yaml
# libjs-jquery-tablesorter and libjs-jquery are needed to look at the generated
# HTML with javascript bling
Recommends:
 libjs-jquery-tablesorter,
 libjs-jquery
# devscripts and libsoap-lite-perl are needed for /usr/bin/bts which is in turn
# needed by botch-cross-problems because there is no soap module for python3
Suggests:
 devscripts,
 libsoap-lite-perl
Description: Bootstrapping helper
 Botch stands for bootstrap/build ordering tool chain and allows one to create
 and analyze bootstrapping dependency graphs, creates suggestions how to break
 dependency cycles and generates a build order.
 .
 It includes a range of utilities to:
 .
  - transform Packages and Sources control files
      - set operations (union, intersection, difference)
      - adding and removing specific metadata
      - only pick latest version
      - Packages to Sources
      - Sources to Packages
      - generating self contained repositories (min and max)
  - analysis of Packages and Sources control files
      - diff tool
      - multiarch changes application
      - check multi-arch:same versions
  - create graphs of different types
      - installation sets
      - strong dependency sets
      - dependency closure
  - conversion of graphs
      - buildgraph to source graph
      - graphml to dot format
      - annotation with strong dependency information
      - extract neighborhood
      - extract strongly connected components
      - collapsing strongly connected components
  - analyze graphs
      - find all cycles
      - find selfcycles
      - find amount of cycles through edges
      - find feedback arc set
      - find feedback vertex set
      - find strong articulation points and strong bridges
      - general graph info
      - generating partial order
      - graph rendering
      - graph difference
      - calculate betweenness
      - calculate port metric
  - shell scripts connecting the tools for meaningful operations
      - analyzing cross bootstrap phase
      - analyzing native bootstrap phase
      - create a transition order

Package: botch-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends:
Suggests:
Description: Bootstrapping helper - documentation
 Botch stands for bootstrap/build ordering tool chain and allows one to create
 and analyze bootstrapping dependency graphs, creates suggestions how to break
 dependency cycles and generates a build order.
 .
 This package contains the documentation.
