=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
OCAML_DEP=
else
OCAML_DEP=ocaml-base-nox-$(shell ocamlc -version)
endif

%:
	dh $@ --with python3

# not stripping binaries as this will lead to random segfaults
override_dh_strip:

override_dh_gencontrol:
	dh_gencontrol -- -Vocaml:Depends=$(OCAML_DEP)
