## botch 0.6

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.4
+VERSION=0.6
 
 BIN_OPT:= \
   create-graph.native \
@@ -14,7 +14,9 @@
   find-fvs.native \
   collapse-srcgraph.native \
   optuniv.native \
-  calculate-fas.native
+  calculate-fas.native \
+  buildcheck-more-problems.native \
+  distcheck-more-problems.native
 
 BIN_BYTE:=$(patsubst %.native, %.d.byte, $(BIN_OPT))
 BIN_PROF:=$(patsubst %.native, %.p.native, $(BIN_OPT))
@@ -41,10 +43,13 @@
 # content with random output order
 #   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=749710
 #   https://github.com/networkx/networkx/issues/1181
+# on the other hand, the generated hashes are not the same on 32 vs 64 arches
+#   http://bugs.python.org/issue22621
+#   http://bugs.debian.org/778373
 export PYTHONHASHSEED=0
 # to make the sort order in the tests locale independent
 export LC_COLLATE=C
-# because cross-problems outputs utf8 on standard output
+# because dose2html outputs utf8 on standard output
 export PYTHONIOENCODING=utf-8
 
 .PHONY: all
@@ -63,9 +68,11 @@
 profile: atdgen
 	OCAMLPATH=$(BUILD) ocamlbuild -classic-display -use-ocamlfind $(CFLAGS) $(BIN_PROF)
 
+doc/man/botch.1: $(MANPAGES)
+	./doc/man/generate-botch-manpage.py | pod2man --section 1 --center="botch tools" --name botch > $@
+
 .PHONY: doc
-doc: $(MANPAGES)
-	./doc/man/generate-botch-manpage.py | pod2man --section 1 --center="botch tools" --name botch > ./doc/man/botch.1
+doc: $(MANPAGES) doc/man/botch.1
 	$(MAKE) -C doc/wiki
 
 doc/man/%.1: doc/man/%.pod
