=== debian/changelog ===
botch (0.6-1~experimental3) experimental; urgency=medium

  * add patch send-keepalive to not abort build on arches without ocamlopt

 -- Johannes Schauer <josch@debian.org>  Sun, 15 Feb 2015 09:55:37 +0100

botch (0.6-1~experimental2) experimental; urgency=medium

  * do not explicitly set `dh_gencontrol -- -Vocaml:Depends` already done by
    dh-ocaml
  * do not run test suite without ocamlopt as that will make the build get
    killed by a timeout (closes: #778449)
  * add dh --with ocaml
  * include /usr/share/ocaml/ocamlvars.mk for OCAML_HAVE_OCAMLOPT
  * Build-Depend on dh-ocaml
  * add lintian overrides for hardening and strip errors

 -- Johannes Schauer <josch@debian.org>  Sun, 15 Feb 2015 08:04:35 +0100

botch (0.6-1~experimental1) experimental; urgency=medium

  * New upstream release (closes: #778373)

 -- Johannes Schauer <josch@debian.org>  Sat, 14 Feb 2015 10:56:50 +0100

botch (0.5-1~experimental3) experimental; urgency=medium

  * this upload removes the build-dependency on python3-yaml:native and the
    dependency on python3-yaml:amd64 to make it compilable/installable again

 -- Johannes Schauer <josch@debian.org>  Thu, 12 Feb 2015 10:57:05 +0100

botch (0.5-1~experimental2) experimental; urgency=medium

  * making an upload to experimental

 -- Johannes Schauer <josch@debian.org>  Fri, 06 Feb 2015 10:45:02 +0100

botch (0.5-1~experimental1) unstable; urgency=medium

  * New upstream release.
    - graph comparison is now done using botch-graph-difference
      (Closes: #764909)
    - adjusted to build with latest dose 3.3 (Closes: #770613)
  * bump dependency on dose lib and tools to 3.3
  * adjust autopkgtests to use botch-graph-difference to compare graphs
  * bump Standards-Version to 3.9.6
  * botch now suggests www-browser because some of its output is HTML
  * change my email in Maintainer field to josch@debian.org
  * add Vcs-Browser and Vcs-Git fields
  * change priority from extra to optional because it has no conflicts and is
    not a debug package
  * add build dependency on python3-yaml:native and dependency on
    python3-yaml:amd64 for testing purposes - please revert!

 -- Johannes Schauer <josch@debian.org>  Fri, 06 Feb 2015 07:26:47 +0100
