=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: botch
 Section: utils
-Priority: extra
-Maintainer: Johannes Schauer <j.schauer@email.de>
+Priority: optional
+Maintainer: Johannes Schauer <josch@debian.org>
 Homepage: https://gitorious.org/debian-bootstrap/pages/Home
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 # all build dependencies after the *-dev dependencies are only needed to run
 # the testsuite
 Build-Depends:
  debhelper (>= 9),
+ dh-ocaml,
  ocaml-nox,
  camlp4,
  python3,
@@ -18,9 +19,9 @@
  libocamlgraph-ocaml-dev,
  libatdgen-ocaml-dev,
  libxmlm-ocaml-dev,
- libdose3-ocaml-dev (>= 3.2.2),
- dose-builddebcheck (>= 3.2.2),
- dose-extra (>= 3.2.2),
+ libdose3-ocaml-dev (>= 3.3),
+ dose-builddebcheck (>= 3.3),
+ dose-extra (>= 3.3),
  dctrl-tools,
  aspcud,
  python3-apt,
@@ -30,6 +31,8 @@
  pep8,
  pyflakes
 XS-Testsuite: autopkgtest
+Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/botch.git/
+Vcs-Git: git://anonscm.debian.org/collab-maint/botch.git
 
 Package: botch
 Architecture: any
@@ -38,8 +41,8 @@
  ${misc:Depends},
  ${shlibs:Depends},
  ${python3:Depends},
- dose-builddebcheck (>= 3.2.2),
- dose-extra (>= 3.2.2),
+ dose-builddebcheck (>= 3.3),
+ dose-extra (>= 3.3),
  dctrl-tools,
  aspcud,
  python3-apt,
@@ -52,9 +55,10 @@
  libjs-jquery-tablesorter,
  libjs-jquery
 # devscripts and libsoap-lite-perl are needed for /usr/bin/bts which is in turn
-# needed by botch-cross-problems because there is no soap module for python3
+# needed by botch-dose2html because there is no soap module for python3
 Suggests:
  devscripts,
+ www-browser,
  libsoap-lite-perl
 Description: Bootstrapping helper
  Botch stands for bootstrap/build ordering tool chain and allows one to create
