=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with python3,ocaml

# not stripping binaries as this will lead to random segfaults
override_dh_strip:
