## botch 0.16

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.6
+VERSION=0.16
 
 BIN_OPT:= \
   create-graph.native \
@@ -6,7 +6,6 @@
   bin2src.native \
   src2bin.native \
   build-fixpoint.native \
-  build-closure.native \
   clean-repository.native \
   buildgraph2srcgraph.native \
   annotate-strong.native \
@@ -21,7 +20,7 @@
 BIN_BYTE:=$(patsubst %.native, %.d.byte, $(BIN_OPT))
 BIN_PROF:=$(patsubst %.native, %.p.native, $(BIN_OPT))
 
-BIN_PYTOOLS:=$(patsubst tools/%.py, %, $(filter-out tools/util.py,$(wildcard tools/*.py)))
+BIN_PYTOOLS:=$(patsubst tools/%.py, %, $(filter-out tools/util.py tools/debarch.py,$(wildcard tools/*.py)))
 BIN_OCTOOLS:=$(patsubst %.native, %, $(BIN_OPT))
 BIN_SHTOOLS:=$(patsubst tools/%.sh, %, $(wildcard tools/*.sh))
 
@@ -34,7 +33,15 @@
 BUILD = $(PWD)/dose/_build
 DOSELIBS = $(PWD)/dose/_build/dose3
 CUDFLIBS = $(PWD)/dose/_build/cudf
-DOSEBYTELIBS = common/common.cma deb/debian.cma rpm/rpm.cma opencsw/csw.cma eclipse/eclipse.cma algo/algo.cma doseparse/boilerplateNoRpm.cma doseparse/boilerplate.cma
+DOSEBYTELIBS = \
+  _build/doselibs/common.cma \
+  _build/doselibs/debian.cma \
+  _build/doselibs/versioning.cma \
+  _build/doselibs/csw.cma \
+  _build/doselibs/pef.cma \
+  _build/doselibs/algo.cma \
+  _build/doselibs/doseparse.cma \
+  _build/doselibs/doseparseNoRpm.cma
 CFLAGS=-cflags "-w +a-4-9"
 bindir=/usr/bin
 datadir=/usr/share/botch
@@ -48,7 +55,8 @@
 #   http://bugs.debian.org/778373
 export PYTHONHASHSEED=0
 # to make the sort order in the tests locale independent
-export LC_COLLATE=C
+export LC_COLLATE=C.UTF8
+export LC_ALL=C.UTF8
 # because dose2html outputs utf8 on standard output
 export PYTHONIOENCODING=utf-8
 
@@ -80,17 +88,19 @@
 
 .PHONY: doselib
 doselib:
-	(cd dose && ./configure --with-zip --with-bz2 --with-ocamlgraph --without-libcudf && make clean fast $(DOSEBYTELIBS))
+	(cd dose && ./configure --with-zip --with-bz2 --with-ocamlgraph --without-libcudf && make clean libs $(DOSEBYTELIBS))
 	rm -Rf $(DOSELIBS)
 	mkdir -p $(DOSELIBS)
 	cp dose/META $(DOSELIBS)
-	for i in dose/_build/*/common.* \
+	for i in \
+		dose/_build/*/common.* \
+		dose/_build/*/versioning.* \
 		dose/_build/*/debian.* \
 		dose/_build/*/algo.* \
 		dose/_build/*/csw.* \
-		dose/_build/*/eclipse.* \
-		dose/_build/*/boilerplate.* \
-		dose/_build/*/boilerplateNoRpm.*; do \
+		dose/_build/*/pef.* \
+		dose/_build/*/doseparseNoRpm.* \
+		dose/_build/*/doseparse.*; do \
 	  if [ -e $$i ]; then \
 	  cp $$i $(DOSELIBS) ; \
 	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
@@ -116,72 +126,75 @@
 .PHONY: atdgen
 atdgen: datatypes_j.ml datatypes_t.ml
 
+# the "while : ; do" loop around graph-difference is a temporary fix to work
+# around random segmentation faults. See http://bugs.python.org/issue24605
 .PHONY: test-default
-test-default: all
+test-default: $(OCAML_BEST)
 	rm -rf tmp out
-	./tools/native.sh --debug --verbose --develop --output out --tmp tmp amd64 tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
+	./tools/native.sh --debug --verbose --develop --output out --tmp tmp --jobs=2 --drop-b-d-indep amd64 tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
 	for f in tests/default/tmp/* tmp/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/default/tmp/$$f" "tmp/$$f" || exit 1;; \
+		*.xml) while : ; do ./tools/graph-difference.py "tests/default/tmp/$$f" "tmp/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/default/tmp/$$f" "tmp/$$f" || exit 1;; \
 		esac; \
 	done
 	for f in tests/default/out/* out/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/default/out/$$f" "out/$$f" || exit 1;; \
+			*.xml) while : ; do ./tools/graph-difference.py "tests/default/out/$$f" "out/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/default/out/$$f" "out/$$f" || exit 1;; \
 		esac; \
 	done
 
 .PHONY: test-selfcontained
-test-selfcontained: all
+test-selfcontained: $(OCAML_BEST)
 	rm -rf tmp out
-	./tools/native.sh --debug --verbose --develop --output out --tmp tmp --latest --clean --self-contained --optuniv --sapsb --strong --no-drop amd64 tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
+	./tools/native.sh --debug --verbose --develop --output out --tmp tmp --drop-b-d-indep --optgraph --latest --clean --self-contained --optuniv --sapsb --strong --no-drop amd64 tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
 	for f in tests/selfcontained/tmp/* tmp/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/selfcontained/tmp/$$f" "tmp/$$f" || exit 1;; \
+			*.xml) while : ; do ./tools/graph-difference.py "tests/selfcontained/tmp/$$f" "tmp/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/selfcontained/tmp/$$f" "tmp/$$f" || exit 1;; \
 		esac; \
 	done
 	for f in tests/selfcontained/out/* out/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/selfcontained/out/$$f" "out/$$f" || exit 1;; \
+			*.xml) while : ; do ./tools/graph-difference.py "tests/selfcontained/out/$$f" "out/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/selfcontained/out/$$f" "out/$$f" || exit 1;; \
 		esac; \
 	done
 
 .PHONY: test-cross
-test-cross: all
+test-cross: $(OCAML_BEST)
 	rm -rf tmp out
 	mkdir out
 	cp tests/cross-ma.diff out/ma.diff
-	./tools/cross.sh --debug --verbose --develop --output=out --tmp=tmp amd64 armhf tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
+	./tools/cross.sh --debug --verbose --develop --output=out --tmp=tmp --drop-b-d-indep --optgraph --jobs=2 amd64 armhf tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
 	for f in tests/cross/tmp/* tmp/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/cross/tmp/$$f" "tmp/$$f" || exit 1;; \
+			*.xml) while : ; do ./tools/graph-difference.py "tests/cross/tmp/$$f" "tmp/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/cross/tmp/$$f" "tmp/$$f" || exit 1;; \
 		esac; \
 	done
 	for f in tests/cross/out/* out/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/cross/out/$$f" "out/$$f" || exit 1;; \
+			*.xml) while : ; do ./tools/graph-difference.py "tests/cross/out/$$f" "out/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/cross/out/$$f" "out/$$f" || exit 1;; \
 		esac; \
 	done
 
-.PHONY: test
-test: test-default test-selfcontained test-cross
+.PHONY: test-man
+test-man: all
 	# test whether there is no manpage without a program by
 	# normalizing program and manpage names and only printing
 	# those names which are not duplicate but unique
 	ls tools/*.py *.$(OCAML_BEST) tools/*.sh doc/man/botch-*.pod \
 		| grep -v tools/util.py \
+		| grep -v tools/debarch.py \
 		| while read pkg; do \
 			pkg=`basename $$pkg .$(OCAML_BEST)`; \
 			pkg=`basename $$pkg .py`; \
@@ -192,12 +205,47 @@
 			echo doc/man/botch-$${pkg}.pod is superfluous >&2; \
 			exit 1; \
 		done
+	# now that we know that there is one man page for every program, check
+	# whether the man page documents all the program options
+	ls tools/*.py *.$(OCAML_BEST) tools/*.sh \
+		| grep -v tools/util.py \
+		| grep -v tools/debarch.py \
+		| grep -v buildcheck-more-problems | grep -v distcheck-more-problems \
+		| while read pkg; do \
+			shortopts=`./$$pkg --help 2>&1 | sed -ne 's/^ \+-\([^ =-]\).*$$/\1/p' | sort`; \
+			longopts=`./$$pkg --help 2>&1 | sed -ne 's/^ \+\(-[^ =-]\+,\)\? --\([^ =]\+\)\([ =].*\)\?$$/\2/p' | sort`; \
+			echo "compare \`./$$pkg --help\` with man page..."; \
+			man=`basename $$pkg .$(OCAML_BEST)`; \
+			man=`basename $$man .py`; \
+			man=`basename $$man .sh`; \
+			man=`basename $$man .pod`; \
+			longman=`sed -ne 's/=item B<[^>]*--\([^>=]\+\)=\?>.*$$/\1/p' doc/man/botch-$${man}.pod | sort`; \
+			shortman=`sed -ne 's/=item B<-\([^>,-]\)[^>]*>.*$$/\1/p' doc/man/botch-$${man}.pod | sort`; \
+			if [ "$$shortopts" != "$$shortman" ]; then \
+				echo "\`./$$pkg --help\` and man page ./$$man disagree:"; \
+				echo "$$shortopts != $$shortman"; \
+				exit 1; \
+			fi; \
+			if [ "$$longopts" != "$$longman" ]; then \
+				echo "\`./$$pkg --help\` and man page ./$$man disagree:"; \
+				echo "$$longopts != $$longman"; \
+				exit 1; \
+			fi; \
+		done
+
+.PHONY: test-python
+test-python:
 	# FIXME: add more tests
 	#./tests.py
 	#OCAMLPATH=$(BUILD) ocamlbuild -classic-display -use-ocamlfind $(CFLAGS) tests.$(OCAML_BEST)
 	#./tests.$(OCAML_BEST)
 	pyflakes3 tools/*.py
-	pep8 tools/*.py
+	# E402 is triggered by the sys.path.append() statement in front of import of utils
+	# see https://github.com/PyCQA/pep8/issues/264
+	pep8 --ignore=E402 tools/*.py
+
+.PHONY: test
+test: test-python test-man test-default test-selfcontained test-cross
 
 .PHONY: install
 install: all
@@ -215,6 +263,7 @@
 	mkdir -p $(DESTDIR)$(datadir)
 	cp -r droppable $(DESTDIR)$(datadir)
 	cp tools/util.py $(DESTDIR)$(datadir)
+	cp tools/debarch.py $(DESTDIR)$(datadir)
 
 .PHONY: clean
 clean:
@@ -223,8 +272,11 @@
 	rm -f tools/*.pyc
 	rm -f *.native *.d.byte
 	rm -f doc/man/*.1
+	$(MAKE) -C doc/wiki clean
+
+.PHONY: distclean
+distclean: clean
 	rm -rf tools/__pycache__ tmp out
-	$(MAKE) -C doc/wiki clean
 
 .PHONY: doseclean
 doseclean:
