=== debian/changelog ===
botch (0.16-2ubuntu2) xenial; urgency=medium

  * No-change rebuild against ocaml 4.02.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Thu, 05 Nov 2015 16:40:35 -0600

botch (0.16-2ubuntu1) wily; urgency=medium

  * Ignore the test results, don't run the autopkg tests. According to
    upstream, there is some dependency of botch that leads to some reordering
    somewhere in the expected test outputs.  Just adjusting the expected
    test results is not an option for now. Find the real issue ...

 -- Matthias Klose <doko@ubuntu.com>  Sat, 03 Oct 2015 23:39:59 +0200

botch (0.16-2) unstable; urgency=medium

  * fix build problem on 32bit architectures

 -- Johannes Schauer <josch@debian.org>  Sun, 27 Sep 2015 13:20:46 +0200

botch (0.16-1) unstable; urgency=medium

  * New upstream release

 -- Johannes Schauer <josch@debian.org>  Sat, 26 Sep 2015 19:28:51 +0200

botch (0.15-4) unstable; urgency=medium

  * and another one...

 -- Johannes Schauer <josch@debian.org>  Sat, 26 Sep 2015 16:10:02 +0200

botch (0.15-3) unstable; urgency=medium

  * another dgit test upload

 -- Johannes Schauer <josch@debian.org>  Sat, 26 Sep 2015 16:02:40 +0200

botch (0.15-2) unstable; urgency=medium

  * dgit test upload

 -- Johannes Schauer <josch@debian.org>  Sat, 26 Sep 2015 14:08:42 +0200

botch (0.15-1) unstable; urgency=medium

  * New upstream release (Closes: #797453)
  * bump dependency on dose tools >= 4.0.1-2
  * remove dependency on jq because it's not needed anymore due to new dose
    tools
  * update botch package description
  * update Vcs-* fields to use dgit

 -- Johannes Schauer <josch@debian.org>  Sat, 26 Sep 2015 08:48:32 +0200

botch (0.14-1) unstable; urgency=medium

  * New upstream release
  * refresh patch send-keepalive
  * botch binary: add dependency on python3-pydot, zutils and suggest
    libgraph-easy-perl, jq
  * update debian/tests/* with --drop-b-d-indep argument and correct locale
    environment variable export
  * make debian/tests/* more readable by splitting long lines
  * update debian/tests/* with workaround for random segmentation faults
    see http://bugs.python.org/issue24605

 -- Johannes Schauer <josch@debian.org>  Wed, 29 Jul 2015 10:10:38 +0200

botch (0.13-1) unstable; urgency=medium

  * New upstream release (closes: #784835)
  * Remove the XS-Testsuite field from d/control to fix lintian warning
    xs-testsuite-header-in-debian-control

 -- Johannes Schauer <josch@debian.org>  Sun, 07 Jun 2015 12:17:15 +0200

botch (0.12-1) unstable; urgency=medium

  * New upstream release (closes: #764704)

 -- Johannes Schauer <josch@debian.org>  Wed, 03 Jun 2015 20:58:37 +0200

botch (0.11-2) unstable; urgency=medium

  * fix last d/changelog entry to say unstable instead of UNRELEASED
    uploads like this should be rejected in the first place. See #647028

 -- Johannes Schauer <josch@debian.org>  Thu, 07 May 2015 08:10:33 +0200

botch (0.11-1) unstable; urgency=medium

  * New upstream release

 -- Johannes Schauer <josch@debian.org>  Wed, 06 May 2015 07:52:20 +0200

botch (0.10-1~experimental1) experimental; urgency=medium

  * New upstream release
  * bump dependency on libdose to 3.3-2 because of its backported fixes for
    fd-leakage and storing the original Debian package name as a cudf_extras
    field

 -- Johannes Schauer <josch@debian.org>  Fri, 27 Mar 2015 12:07:59 +0100

botch (0.9-1~experimental1) experimental; urgency=medium

  * New upstream release
  * add build dependency on libparmap-ocaml-dev

 -- Johannes Schauer <josch@debian.org>  Mon, 23 Mar 2015 21:34:37 +0100

botch (0.8-1~experimental1) experimental; urgency=medium

  * New upstream release

 -- Johannes Schauer <josch@debian.org>  Fri, 20 Mar 2015 17:08:34 +0100

botch (0.7-1~experimental1) experimental; urgency=medium

  * New upstream release
  * replace gitorious upstream url with gitlab.mister-muffin.de

 -- Johannes Schauer <josch@debian.org>  Fri, 20 Mar 2015 08:17:29 +0100
