=== debian/rules ===
--- 
+++ 
@@ -5,5 +5,16 @@
 %:
 	dh $@ --with python3,ocaml
 
+derivative :=   $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
+			elif dpkg-vendor --derives-from Debian; then echo Debian; \
+			else echo Unknown; fi)
+
+override_dh_auto_test:
+ifeq ($(derivative),Ubuntu)
+	-dh_auto_test
+else
+	dh_auto_test
+endif
+
 # not stripping binaries as this will lead to random segfaults
 override_dh_strip:
