=== debian/tests/control ===
Tests: default selfcontained cross
Restrictions: allow-stderr
