=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
http://mister-muffin.de/botch/ \./botch-([\d\.]+)\.tar\.xz
